{known_script id="jquery.ui" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.core.packed.js"}
{known_script id="jquery.ui.sortable" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.sortable.packed.js"}
{known_script id="jquery.ui.dialog" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.dialog.packed.js"}
{known_script id="maps.google.com/api" src="http://maps.google.com/maps/api/js?sensor=false"}


{literal}

<script type="text/javascript">


  function assocManager ()
  {
    var properties = {
      id:'',
    }


    /**
     * initialize the page
     */
    this.init = function ()
    {

      $('#iDialogEdit')
        .dialog(
          {
            autoOpen:false,
            width:800,
            height:450,
            modal: true,
            dialogClass: 'gcBgTabSheet gcBorder',
            title: '{/literal}{"gmaps_manage_assoc"|@translate}{literal}',
            buttons:
              {
                '{/literal}{"gmaps_ok"|@translate}{literal}':
                  function()
                  {
                    if(checkValidity()) doUpdate();
                  },
                '{/literal}{"gmaps_cancel"|@translate}{literal}':
                  function()
                  {
                    $('#iDialogEdit').dialog("close");
                  }
              }
          }
        );

      $('#iBDAssocMapId').bind('change', changeMapDisplayType);

      loadList();

    }

    /**
     * called when the map is changed
     * refresh the icon list
     */
    var changeMapDisplayType = function ()
    {
      switch($('#iBDAssocMapId option:selected').attr('dtype'))
      {
        case 'IC':
        case 'IP':
          $('#iBDAssocIconRow').show();
          break;
        case 'MP':
          $('#iBDAssocIconRow').hide();
          break;
      }
    }


    /**
     * manage the tabsheet
     *
     * @param String tabsheet : id of the tabsheet to display
     */
    this.displayTab = function (tabsheet)
    {
      switch(tabsheet)
      {
        case 'integration':
          $('#iTabIntegration').css('display', 'block');
          $('#iTabAssoc').css('display', 'none');
          break;
        case 'assoc':
          $('#iTabIntegration').css('display', 'none');
          $('#iTabAssoc').css('display', 'block');
          break;
      }
    }


    /**
     * open the dialog box to edit the association properties
     *
     * @param String id : if set to '' => open dialogbox in 'add' mode
     *                    otherwise edit the given association
     */
    this.editAssoc = function (id)
    {
      properties.id=id;
      updateDialog('');
      this.displayTab('assoc');
      // >> because li items don't have id... :-(
      $('#itab2 li').removeClass('selected_tab').addClass('normal_tab');
      $('#itab2 li:first').addClass('selected_tab');
      // <<

      $('#iDialogEdit')
        .bind('dialogopen', function ()
          {
            if(properties.id!='')
            {
              displayProcessing(true);

              $.ajax(
                {
                  type: "POST",
                  url: "{/literal}{$datas.urlRequest}{literal}",
                  async: true,
                  data: { ajaxfct:"admin.assoc.getAssoc", id:properties.id },
                  success:
                    function(msg)
                    {
                      updateDialog(msg);
                      displayProcessing(false);
                    }
                }
              );
            }
          }
        )
        .dialog("open");
    }

    /**
     * delete an association
     *
     * @param String id : id of the association to delete
     */
    this.deleteAssoc = function (id)
    {
      $('#iDialogDelete')
        .html('<br>{/literal}{"gmaps_pleaseConfirmAssoc"|@translate}{literal}')
        .dialog(
          {
            autoOpen:true,
            modal: true,
            dialogClass: 'gcBgTabSheet gcBorder',
            title: '{/literal}{"gmaps_deleteAssoc"|@translate}{literal}',
            buttons:
              {
                '{/literal}{"gmaps_delete"|@translate}{literal}':
                  function()
                  {
                    $(this).html("<br><img src='./plugins/GrumPluginClasses/icons/processing.gif'>");
                    $.ajax(
                      {
                        type: "POST",
                        url: "{/literal}{$datas.urlRequest}{literal}",
                        async: true,
                        data: { ajaxfct:"admin.assoc.deleteAssoc", id:id },
                        success:
                          function(msg)
                          {
                            $('#iDialogDelete').dialog("destroy");
                            loadList();
                          }
                      }
                    );
                  },
                '{/literal}{"gmaps_cancel"|@translate}{literal}':
                  function()
                  {
                    $('#iDialogDelete').dialog("destroy");
                  }
              }
          }
        );
    }

    /**
     * update values of the dialog box
     *
     * @param String items : json string ; if empty assume to reset all fields
     *                       with blank
     */
    var updateDialog = function (items)
    {
      if(items=='')
      {
        $('#iBDAssocCatId').val(0);
        $('#iBDAssocMapId').val($('#iBDAssocMapId option:first').val());
        $('#iBDAssocApplySubCat').val('y');
        $('#iBDAssocKmlFileUrl').val('');
        $('#iBDAssocIcon').val($('#iBDAssocIcon option:visible:first').val());
        $('#iBDAssocTitle').val('');
      }
      else
      {
        tmp=$.parseJSON(items);

        $('#iBDAssocCatId').val(tmp.categoryId);
        $('#iBDAssocMapId').val(tmp.mapId);
        $('#iBDAssocApplySubCat').val(tmp.applySubCat);
        $('#iBDAssocKmlFileUrl').val(tmp.kmlFileUrl);
        $('#iBDAssocIcon').val(tmp.icon);
        $('#iBDAssocTitle').val(tmp.title);
      }

      changeMapDisplayType();
    }

    /**
     * reload the assocation list
     */
    var loadList = function ()
    {
      $('#iListAssoc').html("<br>{/literal}{'gmaps_loading'|@translate}{literal}<br><img src='./plugins/GrumPluginClasses/icons/processing.gif'>");

      $.ajax(
        {
          type: "POST",
          url: "{/literal}{$datas.urlRequest}{literal}",
          async: true,
          data: { ajaxfct:"admin.assoc.getList" },
          success:
            function(msg)
            {
              $("#iListAssoc").html(msg);
            }
        }
      );
    }


    /**
     * check for the validity of the map settings
     */
    var checkValidity = function ()
    {
      $('.error').removeClass('error');
      ok=true;
/*
      if(checkIdValidity($('#iBDMapId').val())==false)
      {
        $('#iBDMapId').addClass('error');
        alert('{/literal}{"gmaps_invalidId"|@translate}{literal}');
        ok=false;
      }
*/
      return(ok);
    }

    /**
     * send assoc update to the server, and close the dialog box if everything
     * is ok
     */
    var doUpdate = function ()
    {
      displayProcessing(true);

      // build datas
      datas = {
        categoryId:$('#iBDAssocCatId').val(),
        mapId:$('#iBDAssocMapId').val(),
        applySubCat:$('#iBDAssocApplySubCat').val(),
        kmlFileUrl:$('#iBDAssocKmlFileUrl').val(),
        icon:$('#iBDAssocIcon').val(),
        title:$('#iBDAssocTitle').val(),
      }

      $.ajax(
        {
          type: "POST",
          url: "{/literal}{$datas.urlRequest}{literal}",
          async: true,
          data: { ajaxfct:"admin.assoc.setAssoc", id:properties.id, datas:datas },
          success:
            function(msg)
            {
              displayProcessing(false);

              if(msg.match(/^[0-9]+$/i)!=null)
              {
                // result Ok ! => close the dialog box and reload the list
                $('#iDialogEdit').dialog("close");
                loadList();
              }
              else
              {
                returned=msg.split('!');
                if(returned[0]!='') $('#'+returned[0]).addClass('error');
                alert(returned[1]);
              }
            }
        }
      );
    }

    /**
     * display or hide the processing flower
     */
    var displayProcessing = function (visible)
    {
      if(visible)
      {
        $('#iBDProcessing').css("display", "block");
      }
      else
      {
        $('#iBDProcessing').css("display", "none");
      }
    }

    this.init();
  }


</script>

{/literal}



<h2>{'gmaps_associate_category_maps'|@translate}</h2>


<div class='addMap'>
  <a onclick="am.editAssoc('');">{'gmaps_add_a_new_association'|@translate}</a>
</div>


<table id='iHeaderListMaps' class="littlefont">
  <tr>
    <th>{'gmaps_category'|@translate}</th>
    <th style="width:90px;">{'gmaps_apply_subcat'|@translate}</th>
    <th style="width:90px;">{'gmaps_mapType'|@translate}</th>
    <th style="width:356px;">{'gmaps_map'|@translate}</th>
    <th style="width:90px;">{'gmaps_map_kmlfile'|@translate}</th>
    <th width="40px">&nbsp;</th>
  </tr>
</table>



<div id='iListAssoc' class="{$themeconf.name}">
</div>
<div id="iListAssocNb"></div>

<div id="iDialogDelete">
</div>

<div id="iDialogEdit">
  <div id='iBDProcessing' style="display:none;position:absolute;width:100%;height:100%;background:#000000;opacity:0.75">
      <img src="plugins/GrumPluginClasses/icons/processing.gif" style="margin-top:100px;">
  </div>

  {$mapTabsheet}
  <form>

    <div id='iTabsContainer' style='height:100px;'>


      <div id='iTabAssoc' style='display:none;'>
        <table class="formtable">
          <tr>
            <td>{'gmaps_map'|@translate}</td>
            <td>
              <select id='iBDAssocMapId'>
                  {foreach from=$datas.maps key=group item=mapGroup}
                    <optgroup label="{'gmaps_displayTypeShort'|cat:$group|@translate}">
                    {foreach from=$mapGroup item=map}
                      <option value='{$map.id}' dtype='{$group}'>{$map.name}</option>
                    {/foreach}
                    </optgroup>
                  {/foreach}
              </select>
            </td>
          </tr>

          <tr>
            <td>{'gmaps_category'|@translate}</td>
            <td>
              <select id='iBDAssocCatId'>
                  {foreach from=$datas.cats item=cat}
                    <option value='{$cat.id}'>{$cat.name}</option>
                  {/foreach}
              </select>
            </td>
          </tr>

          <tr>
            <td>{'gmaps_apply_subcat'|@translate}</td>
            <td>
              <select id='iBDAssocApplySubCat'>
                <option value='y'>{'gmaps_y'|@translate}</option>
                <option value='n'>{'gmaps_n'|@translate}</option>
              </select>
            </td>
          </tr>

        </table>
      </div>


      <div id='iTabIntegration' style='display:none;'>
        <table class='formtable'>

          <tr id='iBDAssocTitleRow'>
            <td>{'gmaps_map_title'|@translate}</td>
            <td>
              <input type="text" id='iBDAssocTitle' value='{$datas.title}' maxlength='200' size='55'>
            </td>
          </tr>

          <tr id='iBDAssocIconRow'>
            <td>{'gmaps_map_icon'|@translate}</td>
            <td>
              <select id='iBDAssocIcon'>
                  {foreach from=$datas.icons item=icon}
                    <option class='{$icon.type}' value='{$icon.file}'>{$icon.file}</option>
                  {/foreach}
              </select>
            </td>
          </tr>

          <tr>
            <td>{'gmaps_map_associate_kmlfile'|@translate}</td>
            <td>
              <input type="text" id="iBDAssocKmlFileUrl" maxlength='255' size='55' value="">
            </td>
          </tr>


        </table>
      </div>

    </div>

  </form>
</div>





{literal}
<script type="text/javascript">
  var am=new assocManager();
</script>
{/literal}

